String.prototype.removeAccents = function () {
    return this
            .replace(/[áàãâä]/gi, "a")
            .replace(/[éè¨ê]/gi, "e")
            .replace(/[íìïî]/gi, "i")
            .replace(/[óòöôõ]/gi, "o")
            .replace(/[úùüû]/gi, "u")
            .replace(/[ç]/gi, "c")
            .replace(/[ñ]/gi, "n")
            .replace(/[^a-zA-Z0-9]/g, " ");
}


// Ionic Starter App

// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
// 'starter.services' is found in services.js
// 'starter.controllers' is found in controllers.js
angular.module('app', ['ionic', 'app.controllers', 'app.routes', 'app.services', 'app.directives', 'ngCordova', 'ionic-modal-select'])
.filter('bitacoraFilter', function () {
    return function (items, filterBy) {
        return items.filter(function (item) {
            return (item.nombre_completo.toLowerCase().removeAccents().indexOf(filterBy.toLowerCase().removeAccents()) > -1) || (item.Casa.toLowerCase().removeAccents().indexOf(filterBy.toLowerCase().removeAccents()) > -1);
        });

    }
})
.filter('salidasFilter', function () {
    return function (items, filterBy) {
        return items.filter(function (item) {
            if(item.placa)
                return (item.nombre_completo.toLowerCase().removeAccents().indexOf(filterBy.toLowerCase().removeAccents()) > -1) || (item.Casa.toLowerCase().removeAccents().indexOf(filterBy.toLowerCase().removeAccents()) > -1) || (item.placa.toLowerCase().removeAccents().indexOf(filterBy.toLowerCase().removeAccents()) > -1);
            else
                return (item.nombre_completo.toLowerCase().removeAccents().indexOf(filterBy.toLowerCase().removeAccents()) > -1) || (item.Casa.toLowerCase().removeAccents().indexOf(filterBy.toLowerCase().removeAccents()) > -1);                
            
        });

    }
})
.filter('casasFilter', function () {
    return function (items, filterBy) {
        return items.filter(function (item) {
            return item.nombre.toLowerCase().removeAccents().indexOf(filterBy.toLowerCase().removeAccents()) > -1 || item.Usuario.toLowerCase().removeAccents().indexOf(filterBy.toLowerCase().removeAccents()) > -1;
        });

    }
})
.filter('morososFilter', function () {
    return function (items, filterBy) {
        return items.filter(function (item) {
            return item.casa.toLowerCase().removeAccents().indexOf(filterBy.toLowerCase().removeAccents()) > -1;
        });

    }
})
.filter('incidentesFilter', function () {
    return function (items, filterBy) {
        return items.filter(function (item) {
            return item.nombre.toLowerCase().removeAccents().indexOf(filterBy.toLowerCase().removeAccents()) > -1;
        });

    }
})
.filter('startFrom', function() {
    return function(input, start) {         
        return input.slice(start);
    }
})
.constant('ApiEndpoint', {
    url: 'https://guardias.kolonus.com/'//'http://guardias.ocirix.com/' //guardias.kolonus.com/    
})
.constant('APPVERSION', {
    version: 53
})
.run(function ($ionicPlatform, $location, $rootScope, $state, $ionicHistory, $cordovaDialogs, $window, GuardiaFactory) {

    $ionicPlatform.registerBackButtonAction(

        function (event) {
            console.log("BACK BUTTON");
            if ($state.current.name == "menu.cambiarContrasena" ||
                $state.current.name == "menu.mantenimientos" ||
                $state.current.name == "menu.incidentes" ||
                $state.current.name == "menu.comunicados" ||
                $state.current.name == "menu.morosos" ||
                $state.current.name == "menu.casas" ||                
                $state.current.name == "menu.salida" ||
                $state.current.name == "menu.entradas") {

                $state.go('menu.bienvenido');

            }else if ($state.current.name == "menu.leerQR" ||
                $state.current.name == "menu.listaIn" ||                
                $state.current.name == "menu.imprevisto") {

                $state.go('menu.bienvenido');
            }else if($state.current.name == "menu.registroIn" || $state.current.name == "menu.registroOut" || $state.current.name == "menu.llamada"){
                $ionicHistory.goBack(-1);
            
            } else if ($state.current.name == "menu.leerQR2" ||
                $state.current.name == "menu.listaOut") {

                    $state.go('menu.bienvenido');

            } else {
                ionic.Platform.exitApp();
            }
        }

    , 100);

    $ionicPlatform.ready(function () {
        var trono = false;
        

        // Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
        // for form inputs)
        //if (window.cordova && window.cordova.plugins.Keyboard) {
        //    cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
        //}
        if (window.StatusBar) {
            // org.apache.cordova.statusbar required
            StatusBar.styleDefault();
        }

        $rootScope.sesion = {
            id_cuenta: 0,
            id_usuario: 0,
            id_sector: 0,
            email: '',
            imei: '000000000000000',
            nombre: '',
            sector: '',
            token: '',
            camera: 25
        }



        var notificationOpenedCallback = function(jsonData) {
            console.log('notificationOpenedCallback: ' + JSON.stringify(jsonData));
            
            if($rootScope.sesion.token != ''){
                $rootScope.$broadcast('push:recive');
            }
        };

        var handleNotificationReceivedCallback = function(jsonData) {
                //alert("Notification received:\n" + JSON.stringify(jsonData));
                console.log('didReceiveRemoteNotificationCallBack: ' + JSON.stringify(jsonData));
                $cordovaDialogs.alert("Usted tiene una nueva notificacion: " + jsonData.payload.title, 'Nuevo', 'Aceptar');
                if($rootScope.sesion.token != ''){
                    $rootScope.$broadcast('push:recive');
                }
            };

        window.plugins.OneSignal
            .startInit("9d763eec-0e2f-4d4e-b9eb-0209ad69ddc7")
            .handleNotificationOpened(notificationOpenedCallback)
            .handleNotificationReceived(handleNotificationReceivedCallback)
            .inFocusDisplaying(window.plugins.OneSignal.OSInFocusDisplayOption.None)
            .endInit();

        
            
        $ionicPlatform.on("resume", function(event) {
            trono = true;
            console.log('app resume event');            
            if(event && event.pendingResult){
                var status = event.pendingResult.pluginStatus !== null ? '' : event.pendingResult.pluginStatus.toUpperCase();
                if ('Camera' === event.pendingResult.pluginServiceName && 'OK' !== status && event.pendingResult.result !== '') {
                    
                    GuardiaFactory.getStatusCamara().then(function(valor){
                        var recuperado = valor;
                        if(valor.pantalla == 'menu.imprevisto'){
                            if(recuperado.imageURL == '')
                            {
                                recuperado.imageURL= event.pendingResult.result;
                            }else if(recuperado.imageURL2 == ''){
                                recuperado.imageURL2= event.pendingResult.result;
                            }
                        }
                        if(valor.pantalla == 'menu.registroIn'){
                            if(recuperado.registroForm.imageURL == '')
                            {
                                recuperado.registroForm.imageURL= event.pendingResult.result;
                            }else if(recuperado.registroForm.imageURL2 == ''){
                                recuperado.registroForm.imageURL2= event.pendingResult.result;
                            }
                        }
                        console.log("se recupero imagen perdida");
                        GuardiaFactory.cleanStatusCamara().then(function(){
                            console.log("termina recuperacion de status camara, se envia a la pantalla");
                            //console.log(recuperado);
                            GuardiaFactory.getSesion("id_usuario", "sesion").then(function(value){
                                $rootScope.sesion.id_usuario = ((value != null) ? value : 0);
                                GuardiaFactory.getSesion("camera", "config").then(function(value){
                                    $rootScope.sesion.camera = ((value != null && value != "") ? value : "25");
                                    GuardiaFactory.getSesion("id_cuenta", "sesion").then(function(value){
                                        $rootScope.sesion.id_cuenta = ((value != null) ? value : 0);
                                        GuardiaFactory.getSesion("id_sector", "sesion").then(function(value){
                                            $rootScope.sesion.id_sector = ((value != null) ? value : 0);
                                            GuardiaFactory.getSesion("email", "sesion").then(function(value){
                                                $rootScope.sesion.email = value;
                                                GuardiaFactory.getSesion("imei", "sesion").then(function(value){
                                                    $rootScope.sesion.imei = value;
                                                    GuardiaFactory.getSesion("nombre", "sesion").then(function(value){
                                                        $rootScope.sesion.nombre = value;
                                                        GuardiaFactory.getSesion("sector", "sesion").then(function(value){
                                                            $rootScope.sesion.sector = value;
                                                            GuardiaFactory.getSesion("token", "sesion").then(function(value){
                                                                $rootScope.sesion.token = value;
                                                                if (navigator && navigator.splashscreen) {
                                                                    navigator.splashscreen.hide();
                                                                }
                                                                //$location.path('/side-menu1/registroImprevisto');
                                                                $state.go(recuperado.pantalla, { bitacora: recuperado });
                                                            },function(){});
                                                        },function(){});
                                                    },function(){});
                                                },function(){$rootScope.sesion.imei = '000000000000000';});
                                            },function(){});
                                        },function(){});
                                    },function(){});
                                },function(){$rootScope.sesion.camera = "25";});
                            },function(err){});
                            
                            
                        }, function(){
                            console.log("error al limpiar statuscamara")
                        })
                        
                    },function(){
                        console.log("no se encontro statusCamara");
                    }
                    );
                }
            }else{
                
                
            }
        });

        if(!trono)
        {
            console.log("Cambiando a login");
            $state.go('menu.kolonus-Caseta'); 
        }

        });
            
       
        
});
