angular.module('app.routes', [])

.config(function ($stateProvider, $urlRouterProvider, $httpProvider) {

    // Ionic uses AngularUI Router which uses the concept of states
    // Learn more here: https://github.com/angular-ui/ui-router
    // Set up the various states which the app can be in.
    // Each state's controller can be found in controllers.js
    $stateProvider



      //.state('menu.kolonus-Caseta', {
      //  url: '/login',
      //  views: {
      //    'side-menu21': {
      //      templateUrl: 'templates/kolonus-Caseta.html',
      //      controller: 'kolonus-CasetaCtrl'
      //    }
      //  }
      //})
      .state('menu.kolonus-Caseta', {
          url: '/login',
          views: {
              'side-menu21': {
                  templateUrl: 'templates/kolonus-Caseta.html',
                  controller: 'kolonusCasetaCtrl'
              }
          }
      }).state('menu.recuperar', {
          url: '/recuperar',
          views: {
              'side-menu21': {
                  templateUrl: 'templates/recuperar.html',
                  controller: 'recuperarCtrl'
              }
          }
      }).state('menu', {
          url: '/side-menu1',
          abstract: true,
          templateUrl: 'templates/menu.html'
      }).state('menu.entradas', {
          url: '/entrada',
          views: {
              'side-menu21': {
                  templateUrl: 'templates/entradas.html',
                  controller: 'entradasCtrl'
              }
          }
      }).state('menu.cerrar', {
          url: '/close',
          views: {
              'side-menu21': {
                  templateUrl: 'templates/close.html',
                  controller: 'closeCtrl'
              }
          }
      }).state('menu.salida', {
          url: '/salida',
          views: {
              'side-menu21': {
                  templateUrl: 'templates/salida.html',
                  controller: 'salidaCtrl'
              }
          }
      }).state('menu.leerQR', {
          url: '/leerQrIn',
          views: {
              'side-menu21': {
                  templateUrl: 'templates/leerQR.html',
                  controller: 'leerQRCtrl'
              }
          }
      }).state('menu.leerQR2', {
          url: '/leerQrOut',
          views: {
              'side-menu21': {
                  templateUrl: 'templates/leerQR2.html',
                  controller: 'leerQR2Ctrl'
              }
          }
      }).state('menu.listaIn', {
          url: '/listaIn',
          views: {
              'side-menu21': {
                  templateUrl: 'templates/ListaEntradas.html',
                  controller: 'listaEntradasCtrl'
              }
          }
      }).state('menu.registroIn', {
          url: '/registroIn',
          views: {
              'side-menu21': {
                  templateUrl: 'templates/rEntrada.html',
                  controller: 'rEntradaCtrl'
              }
          },
          params: {
              bitacora: {}
          }
      }).state('menu.imprevisto', {
          url: '/registroImprevisto',
          views: {
              'side-menu21': {
                  templateUrl: 'templates/imprevisto.html',
                  controller: 'rImprevistoCtrl'
              }
          },
          params: {
              bitacora: {}
          }
      }).state('menu.listaOut', {
          url: '/listaOut',
          views: {
              'side-menu21': {
                  templateUrl: 'templates/listaSalidas.html',
                  controller: 'listaSalidaCtrl'
              }
          }
      }).state('menu.registroOut', {
          url: '/registroOut',
          views: {
              'side-menu21': {
                  templateUrl: 'templates/rSalida.html',
                  controller: 'rSalidaCtrl'
              }
          },
          params: {
              bitacora: {}
          }
      }).state('menu.casas', {
          url: '/casas',
          views: {
              'side-menu21': {
                  templateUrl: 'templates/casas.html',
                  controller: 'casasCtrl'
              }
          }
      }).state('menu.llamada', {
        url: '/llamada',
        views: {
            'side-menu21': {
                templateUrl: 'templates/llamada.html',
                controller: 'llamadaCtrl'
                }
            },
            params: {
                casa: {}
            }
        }).state('menu.morosos', {
          url: '/moroso',
          views: {
              'side-menu21': {
                  templateUrl: 'templates/morosos.html',
                  controller: 'morososCtrl'
              }
          }
      }).state('menu.comunicados', {
          url: '/comunicado',
          views: {
              'side-menu21': {
                  templateUrl: 'templates/comunicados.html',
                  controller: 'comunicadosCtrl'
              }
          }
      }).state('menu.incidentes', {
          url: '/incidente',
          views: {
              'side-menu21': {
                  templateUrl: 'templates/incidentes.html',
                  controller: 'incidentesCtrl'
              }
          }
      }).state('menu.mantenimientos', {
          url: '/mtto',
          views: {
              'side-menu21': {
                  templateUrl: 'templates/mantenimientos.html',
                  controller: 'mantenimientosCtrl'
              }
          }
      }).state('menu.cambiarContrasena', {
          url: '/password',
          views: {
              'side-menu21': {
                  templateUrl: 'templates/cambiarContrasena.html',
                  controller: 'cambiarContrasenaCtrl'
              }
          }
      }).state('menu.configuracion', {
        url: '/config',
        views: {
            'side-menu21': {
                templateUrl: 'templates/config.html',
                controller: 'configuracionCtrl'
            }
        }
    }).state('menu.camaraIP', {
        url: '/camaras',
        views: {
            'side-menu21': {
                templateUrl: 'templates/camara-ip.html',
                controller: 'camaraIpCtrl'
            }
        },
        params: {
            id_camara: 0
        }
    }).state('menu.bienvenido', {
          url: '/home',
          views: {
              'side-menu21': {
                  templateUrl: 'templates/bienvenido.html',
                  controller: 'bienvenidoCtrl'
              }
          }
      });

    // if none of the above states are matched, use this as the fallback
    //$urlRouterProvider.otherwise('/side-menu1/login');
    $httpProvider.interceptors.push(function ($q, $rootScope, $location) {
        return {
            request: function (config) {
                if (config.url.indexOf('http') != -1) {
                    $rootScope.$broadcast('loading:show')

                    if(config.url.indexOf('twil') == -1 && config.url.indexOf('GetSnapshot') == -1 && config.url.indexOf('ISAPI') == -1) {
                        if ($rootScope.sesion != null)
                            if ($rootScope.sesion.token != ''){
                                config.headers['Authorization'] = 'Bearer ' + $rootScope.sesion.token;
                                config.headers['Content-Type'] = 'application/json';
                            }
                    }
                } 
                return config
            },
            response: function (response) {
                if (response.config.url.indexOf('http') != -1)
                    $rootScope.$broadcast('loading:hide')
                return response || $q.when(response);
            },
            responseError: function (response) {
                console.log(response);
                if (response.config.url.indexOf('http') != -1) {
                    $rootScope.$broadcast('loading:hide')
                    if (response.status === 401) {
                        //alert("TOKEN ERROR " + $rootScope.sesion.token);
                        //alert(response.config.url);
                        console.log("Response Error 401", response);
                        $location.path('/side-menu1/close')
                    }

                }
                return $q.reject(response);
            }

        }
    })
});